Page MenuHomePhabricator

modules: Rename EAPI macro to MODAPI for modules
ClosedPublic

Authored by felipealmeida on Jan 1 2021, 12:53 PM.

Details

Summary

Patch from a series of patches to rename EAPI symbols to specific
library DSOs.

The Rationale

EAPI was designed to be able to pass
__attribute__ ((visibility ("default"))) for symbols with
GCC, which would mean that even if -fvisibility=hidden was used
when compiling the library, the needed symbols would get exported.

MSVC almost works like GCC (or mingw) in which you can
declare everything as export and it will just work (slower, but
it will work). But there's a caveat: global variables will not
work the same way for MSVC, but works for mingw and GCC.

For global variables (as opposed to functions), MSVC requires
correct DSO visibility for MSVC: instead of declaring a symbol as
export for everything, you need to declare it as import when
importing from another DSO and export when defining it locally.

With current EAPI definitions, we get the following example
working in mingw and MSVC (observe it doesn't define any global
variables as exported symbols).

Example 1:
dll1:

EAPI void foo(void);

EAPI void bar()
{
  foo();
}

dll2:

EAPI void foo()
{
  printf ("foo\n");
}

This works fine with API defined as __declspec(dllexport) in both
cases and for gcc defining as
__atttribute__((visibility("default"))).

However, the following:
Example 2:

dll1:

EAPI extern int foo;
EAPI void foobar(void);

EAPI void bar()
{
  foo = 5;
  foobar();
}

dll2:

EAPI int foo = 0;
EAPI void foobar()
{
  printf ("foo %d\n", foo);
}

This will work on mingw but will not work for MSVC. And that's why
EAPI is the only solution that worked for MSVC.

Co-authored-by: João Paulo Taylor Ienczak Zanette <jpaulotiz@gmail.com>
Co-authored-by: Ricardo Campos <ricardo.campos@expertise.dev>
Co-authored-by: Lucas Cavalcante de Sousa <lucks.sousa@gmail.com>

Diff Detail

Repository
rEFL core/efl
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
felipealmeida created this revision.Jan 1 2021, 12:53 PM
felipealmeida requested review of this revision.Jan 1 2021, 12:53 PM
lucas added inline comments.Jan 5 2021, 4:47 AM
src/modules/evas/engines/gl_generic/evas_ector_gl.h
5

This one doesn't have # ifndef EFL_MODULE_STATIC is it as you expected @felipealmeida ?

felipealmeida marked an inline comment as done.Jan 6 2021, 8:13 AM
felipealmeida added inline comments.
src/modules/evas/engines/gl_generic/evas_ector_gl.h
5

There wasn't this option before. So I just kept the same behavior.

Unknown Object (User) added a subscriber: Unknown Object (User).Jan 12 2021, 12:48 AM
This comment was removed by raster.
Unknown Object (User) added a comment.Jan 12 2021, 12:50 AM
This comment was removed by raster.
raster added a subscriber: raster.Jan 12 2021, 1:39 AM
Unknown Object (User) accepted this revision.Jan 23 2021, 7:08 AM
Unknown Object (User) added a subscriber: Unknown Object (User).
This comment was removed by Unknown Object (User).
This revision is now accepted and ready to land.Jan 23 2021, 7:08 AM
vtorri accepted this revision.Feb 8 2021, 5:30 AM

compiles and etui compiles too

This revision was automatically updated to reflect the committed changes.
felipealmeida marked an inline comment as done.